--Sounds
local EMOTE_SOUNDS = {sfx_s3k63, sfx_s3k63, sfx_3db06, sfx_adderr, sfx_notadd, sfx_kc5d, sfx_bruh}
local EMOTE_STATES = {S_ALART1, S_EMOTE2, S_EMOTE3, S_EMOTE4, S_EMOTE5, S_EMOTE6, S_EMOTE7}
local SND_HELPME = sfx_alart
local SND_PINGSPAM = sfx_s3k67

--Print for player only
local function printF(player,str)
	if consoleplayer == player
		print(str)
	end
end

--Workaround to get the consoleplayer's camera mobj... ugh
local consoleplayer_camera = nil
local function getcam(v, player, camera)
    consoleplayer_camera = camera
end
hud.add(getcam, "game")

--Arrow thinker
addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid
		local t = mo.target
		local fp = false
		if t.player and t.player.valid and (t.player == consoleplayer) and consoleplayer_camera and (consoleplayer_camera.chase == false)
			fp = true
		end

		if mo.helptarget and mo.helptarget.valid--I am looking for my teammate who is calling for help
			local xx = t.x
			local yy = t.y
			local zz = t.z
			mo.angle = R_PointToAngle2(xx, yy, mo.helptarget.x, mo.helptarget.y)
			if fp
				local xoff = cos(mo.angle) * 30
				local yoff = sin(mo.angle) * 30
				xx = $ + xoff
				yy = $ + yoff
				zz = $ + (20 * FRACUNIT)
				
				if mo.state == S_HELPARR
					mo.state = S_ALART1
				end
				mo.scale = t.scale/6
			else
				mo.state = S_HELPARR
				mo.scale = t.scale
			end
			P_TeleportMove(mo, xx, yy, zz)
		end
		
		return
	end
	
	if mo.needhelptarget and mo.needhelptarget.valid--I am calling for help
		P_TeleportMove(mo, mo.needhelptarget.x, mo.needhelptarget.y, mo.needhelptarget.z + 55 *mo.needhelptarget.scale)
	end
end, MT_GHOST)

--Ping system
addHook("PlayerThink", function(player)
	--Ping system
	local wepbtn = player.cmd.buttons & BT_WEAPONMASK
	if player.pwepbtn == nil
		player.pwepbtn = wepbtn
	end
	
	if player.pingspam == nil
		player.pingspam = 0
	end
	if player.pingspam > 0
		player.pingspam = $ - 1
	end
	
	if wepbtn and player.pwepbtn == 0 and player.mo and player.mo.valid and not player.spectator
		player.pingspam = $ + 56
		if player.pingspam >= 5 * TICRATE
			player.pingspam = 6 * TICRATE
			printF(player,"\133Too many emotes - slow down!")
			S_StartSoundAtVolume(nil,SND_PINGSPAM,200,player)
		
		else
			local mo = player.mo
			local scale = player.mo.scale
			local pingsound = EMOTE_SOUNDS[wepbtn]
			local teamonly = false
			local help = false
			local ping = P_SpawnMobj(mo.x,mo.y,mo.z + 45 *scale,MT_GHOST)
			ping.fuse = 3/2 * TICRATE
			ping.momz = scale / 2
			ping.scale = scale * 3 / 2
			ping.destscale = ping.scale
			ping.state = EMOTE_STATES[wepbtn]
			
			local seeping = false
			if isdedicatedserver or (gametyperules & GTR_FRIENDLY)
				seeping = true
			
			elseif consoleplayer.ctfteam == player.ctfteam
				seeping = true
			
			elseif consoleplayer.spectator
				seeping = true
			end
			
			if wepbtn == 1--Help me ping
				if (gametyperules & GTR_TEAMS) or (gametyperules & GTR_FRIENDLY)
					pingsound = SND_HELPME
					teamonly = true
					help = true
					ping.colorized = true
					ping.fuse = 4 * TICRATE
					if player.ctfteam == 1
						ping.color = SKINCOLOR_RED
					elseif player.ctfteam == 2
						ping.color = SKINCOLOR_BLUE
					end
					player.pingspam = 8 * TICRATE
					
					for player2 in players.iterate
						if player2.mo and player2.mo.valid and player2 != player
							local arr = P_SpawnMobj(player2.mo.x,player2.mo.y,player2.mo.z, MT_GHOST)
							arr.state = S_HELPARR
							arr.target = player2.mo
							arr.helptarget = ping
							arr.fuse = ping.fuse
							arr.color = player.mo.color
							arr.colorized = true
							if player2 != consoleplayer or not seeping
								arr.flags2 = $ | MF2_DONTDRAW
							end
						end
					end
				end
				ping.needhelptarget = mo
				ping.scale = $ * 5 / 12
			end
			
			if teamonly
				if seeping and help
					local endtext = "!"
					if (not isdedicatedserver)
						if consoleplayer != player
							local cpm = consoleplayer.mo
							if cpm and cpm.valid
								if R_PointToDist2(mo.x,mo.y,cpm.x,cpm.y) < 3000 * FRACUNIT
									endtext = " from nearby!"
								elseif R_PointToDist2(mo.x,mo.y,cpm.x,cpm.y) > 6000 * FRACUNIT
									endtext = " from far away!"
								end
							end
						end
					end
					print("\x82"..player.name.." is requesting help"..endtext)
				end
				if seeping == false
					ping.flags2 = $ | MF2_DONTDRAW
				end
			end
			
			if (teamonly and seeping) or (not teamonly)
				if help
					S_StartSound(nil,pingsound,nil)
				else
					S_StartSound(mo,pingsound,nil)
				end
			end
		end
	end
	player.pwepbtn = wepbtn
end)